module (..., package.seeall)

default_action = "system"

-- Public methods

system = function (self )
	return self.model:get_system()
end

storage = function (self )
	return self.model:get_storage()
end

network = function (self )
	return self.model:get_network()
end

modules = function (self )
	return self.model:get_modules()
end

proc = function (self )
	return self.model:get_proc()
end

networkstats = function(self)
	local retval = self.model.get_networkstats()
	if self.clientdata.viewtype then
		self.conf.viewtype = "ajax"
	else
		local intf = self:new("alpine-baselayout/interfaces")
		local interfaces = intf.model.get_addresses()
		intf:destroy()
		for i,intf in ipairs(interfaces.value) do
			if retval.value[intf.interface] then
				retval.value[intf.interface].ipaddr = intf.ipaddr
			end
		end
	end
	return retval
end
